//
//  HDZCustomMenusScroll.m
//  内涵段子demo
//
//  Created by 黄feilong on 16/10/24.
//  Copyright © 2016年 feilong. All rights reserved.
//  上面滑动的菜单

#import "HDZCustomMenusScroll.h"

@interface HDZCustomMenusScrollItem : UILabel
@property (nonatomic,assign)BOOL selected;
@end

@implementation HDZCustomMenusScrollItem

-(instancetype)init{
    
    if (self = [super init]){
        self.textColor = [UIColor colorWithRed:0.62 green:0.85 blue:0.80 alpha:1.0];
        self.textAlignment = NSTextAlignmentCenter;
    }
    return self;
}

-(void)setSelected:(BOOL)selected
{
    _selected = selected;
    if(_selected){
        self.textColor = [UIColor orangeColor];
    }else{
        self.textColor = [UIColor colorWithRed:0.62 green:0.85 blue:0.80 alpha:1.0];
    }
}

@end


@implementation HDZCustomMenusScroll{
    NSArray *_titleArray;
    HDZCustomMenusScrollItem *_selectedItem;
}

-(void)setUpTitleArrays:(NSArray *)array
{
    _titleArray = array.copy;
    self.showsVerticalScrollIndicator = NO;
    self.showsHorizontalScrollIndicator = NO;
    self.backgroundColor = [UIColor colorWithRed:0.85 green:0.85 blue:0.85 alpha:1.0];
    if(_titleArray.count>0){
        for(int i=0;i<_titleArray.count;i++){
            HDZCustomMenusScrollItem *item = [[HDZCustomMenusScrollItem alloc] init];
            item.text = _titleArray[i];
            item.frame = CGRectMake(i*60, 0, 60, self.frame.size.height);
            item.userInteractionEnabled = YES;
            [item addGestureRecognizer:[[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(selectedItems:)]];
            item.tag = i+10;
            [self addSubview:item];
            if (i==0) {
                _selectedItem = item;
                _selectedItem.selected = YES;
            }
        }
    }
    self.contentSize = CGSizeMake(60*_titleArray.count, self.frame.size.height);
    
}

- (void)selectedItems:(UITapGestureRecognizer *)sender
{
    HDZCustomMenusScrollItem *label = (HDZCustomMenusScrollItem *)sender.view;
    _selectedItem.selected = NO;
    label.selected = YES;
    _selectedItem = label;
    CGFloat KscreenWidth = [UIScreen mainScreen].bounds.size.width;
    if(label.center.x>KscreenWidth/2){
        
        if (label.center.x<self.contentSize.width-KscreenWidth/2) {
            
            [self setContentOffset:CGPointMake((label.center.x-KscreenWidth/2), 0) animated:YES];
        }
    }
    
    if(self.menuScrollerDidSelectItem){
        self.menuScrollerDidSelectItem(self,label.text,label.tag-10);
    }
}


@end
